/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package de.unima.crumbtrail.pruner;

import com.google.common.collect.HashMultimap;
import com.google.common.collect.Multimap;
import it.uniroma1.lcl.jlt.util.IntegerCounter;
//import static de.unima.smartpruning.pruner.ClosureThread.fastGreedyClosure;
import java.io.IOException;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.concurrent.Callable;
import org.jgrapht.alg.BellmanFordShortestPath;
import org.jgrapht.graph.DefaultDirectedGraph;
import org.jgrapht.graph.DefaultEdge;

/**
 *
 * @author sfaralli
 */
public class PassingThread implements Callable
{
    List<String> level;

    DefaultDirectedGraph<String,DefaultEdge> result;
    HashMultimap<String, String> passing;
    HashMultimap<String, String> passingk;
    Set<String> goods;
    Set<String> K;
    int id=-1;
    int h;
    int actual=0;
    int total=0;
    public boolean done=false;
    Set<String> analyzed;
    Set<String> essential;
    String root;
    IntegerCounter<String> node2goods;
    IntegerCounter<String> node2ks;
    //Multimap<String,String> cause;
    // here
 //  Multimap<String,String> closure;
    public PassingThread(int id,int h,List<String> level,
            HashMultimap<String, String> passing,
            HashMultimap<String, String> passingk,
            DefaultDirectedGraph<String,DefaultEdge> result,
            Set<String> goods,
            Set<String> K,
            String root,
            Set<String> analyzed,
            Set<String> essential,
            IntegerCounter<String> node2goods,
            IntegerCounter<String> node2ks
            // here
   //         Multimap<String,String> closure
    
    )
    {
    this.result=result;
    this.id=id;
    this.h=h;
    this.K=K;
    this.goods=goods;
    this.level=level;
    this.passing=passing;
    this.passingk=passingk;
    this.analyzed=analyzed;
    this.essential=essential;
    this.root=root;
    this.node2goods=node2goods;
    this.node2ks=node2ks;
    }
    
    public int getOverall()
    {
        return passing.keySet().size();
    }
    public int getActual()
    {
        return actual;
    }
    public int getTotal()
    {
        return total;
    }
    public void run() throws IOException 
    {
        //int k=0;
      int size=level.size();
      total=size;
      try{
            for (String s:level)
            {
                           if (s == null) {
                                continue;
                            }
                            if (s.trim().isEmpty()) {
                                continue;
                            }
                            if (!result.containsVertex(s)) continue;
                                
                            //BellmanFordShortestPath bfv = new BellmanFordShortestPath(result, s);
                            actual++;
                            /*if (actual % 300 == 0) {
                                String text = actual + "/" + size;
                                de.unima.smartpruning.utility.ScreenUpdate.printText(text, 3, 1);
                            }*/
				Set<String> goodessential=new HashSet<String>(essential);
				goodessential.addAll(goods);
                            BellmanFordShortestPath<String, DefaultEdge> bresults = new BellmanFordShortestPath(result, s);
                            for (String g : goods) 
                            {
                                if (!g.equals(s) && result.containsVertex(g)) 
                                {
                                        Double cost = Double.POSITIVE_INFINITY;
                                        List<DefaultEdge> bf = bresults.getPathEdgeList(g);
                                        if (bf != null&&!bf.isEmpty()) 
                                        {
                                              cost = new Double(bf.size());
                                        }
                                    if (cost!=Double.POSITIVE_INFINITY) 
                                    {
                                        passing.put(g, s);
                                        analyzed.add(s);
                                        node2goods.count(s);
                                    }
                                }

                            }//for
                            Set<String> kr = new HashSet<String>(K);
                            kr.add(root);
                            for (String k : kr) {

                                if (!k.equals(s) && result.containsVertex(k)) {
                                    BellmanFordShortestPath bfa = new BellmanFordShortestPath(result, k);
                                    //List<DefaultEdge> pp = BellmanFordShortestPath.findPathBetween(result, k, s);
                                    Double cost = bfa.getCost(s);
                                    if (!cost.equals(Double.POSITIVE_INFINITY)) {
                                        passingk.put(k, s);
                                        node2ks.count(s);
                                    }
                                }

                            }//for

					//K.remove(root);


            }
        }
        catch (Exception e)
          {
              System.out.println(e.getMessage());
          //    System.exit(0);
          }
	done=true;	  
      }
        
        
        
        
        /*for (String source : level )
                        {
                            try {
                                            Thread.sleep(200);
                                        } catch (InterruptedException ex) {
                                           
                                        }
                            k++;
                            
                            //System.out.println("Thread:"+id+" "+k+"/"+level.size());
                            
                            Set<String> bblevel = new HashSet<String>(nextlevel);
                         //   bblevel.removeAll(removedhere);
                            bblevel.remove(source);
                            BellmanFordShortestPath sp= new BellmanFordShortestPath(result,source);
                            
                                for (String target : bblevel) 
                                {
                                    
                                    if (removedhere.contains(target)) continue;
                                    Double cost=sp.getCost(target);
                                    if (cost!=Double.POSITIVE_INFINITY)
                                    {
                                                    pushed.put(z+h,source);
                                                   removedhere.add(source);
                                                System.out.println("Thread:"+id+" "+k+"/"+level.size()+" pushed:"+source+" -> "+(z+h));
                                                bw.write("Thread:"+id+" "+k+"/"+level.size()+" pushed:"+source+" -> "+(z+h)+"\n");
                                        break;
                                    } 
                                 }
                       }*/
    

    @Override
    public Object call() throws Exception 
    {
      //  System.out.println("Thread:"+id+" called");
       run();
     //  System.out.println("Thread:"+id+" finished");
       return true;
    }
    
    
}
