/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package de.unima.crumbtrail.pruner;

import com.google.common.collect.HashMultimap;
import com.google.common.collect.Multimap;
//import static de.unima.smartpruning.pruner.ClosureThread.fastGreedyClosure;
import java.io.IOException;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Random;
import java.util.Set;
import java.util.concurrent.Callable;
import org.jgrapht.alg.BellmanFordShortestPath;
import org.jgrapht.graph.DefaultDirectedGraph;
import org.jgrapht.graph.DefaultEdge;

/**
 *
 * @author sfaralli
 */
public class LevelThread implements Callable 
{

    private final static int jump=9999;    
    List<String> level;
    Multimap<Integer, String> pushed;
    Set<String> pumped;
    Set<String> saved;
    List<String> nextlevel;
    DefaultDirectedGraph<String, DefaultEdge> result;
    Map<String, Integer> n2l;
    HashMultimap<String, String> testedpostponed;
    int id = -1;
    int h;

    int actual = 0;
    int total = 0;
    public boolean done = false;
    private Random rand = new Random(12345);
    //Multimap<String,String> cause;
    // here
    //  Multimap<String,String> closure;

    public LevelThread(int id, int h, List<String> level,
            Multimap<Integer, String> pushed,
            Map<String, Integer> n2l,
            Set<String> pumped,
            Set<String> saved,
            List<String> nextlevel,
            DefaultDirectedGraph<String, DefaultEdge> result,
              HashMultimap<String, String> testedpostponed
            
    //,
    // here
    //         Multimap<String,String> closure

    ) {
        this.n2l = n2l;
        this.level = level;
        this.pushed = pushed;
        this.pumped = pumped;
        this.nextlevel = nextlevel;
        this.result = result;
        this.saved = saved;
//this.causeof=causeof;
        this.id = id;
        this.h = h;
        this.testedpostponed = testedpostponed;
    //this.cause=cause;
        //  this.closure=closure;
        // System.out.println("Thread:"+id+" created");
    }

    public int getOverall() {
        return pumped.size();
    }

    public int getActual() {
        return actual;
    }

    public int getTotal() {
        return total;
    }

    public synchronized void run() throws IOException{
        //int k=0;
        int size=level.size();
        total=size;
      try{
      for (String s:level)
      {
          actual++;
          //if (saved.contains(s)) continue;
          if (pumped.contains(s)) continue;
          if (!result.containsVertex(s)) continue;
    	  BellmanFordShortestPath<String,DefaultEdge> bf= new  BellmanFordShortestPath(result, s);
          if (bf==null) continue;
          // here
    	  for (String t:nextlevel)
          {
              //if (testedpostponed.containsEntry(s, t)) continue;
           //  if (saved.contains(t)) continue;
             if (!result.containsVertex(t)) continue;
    		  if (!s.equals(t)/*&&pumped.size()<nextlevel.size()-1&&closure.containsEntry(s,t)*/) 
    		  {
                          Double cost=bf.getCost(t);
                       // Double delta=cost+jump; // originale
                       //    Double delta=(double)jump;
                      //    Double delta=Math.max(1.0,(double)rand.nextDouble()*(double)cost); // 
                          Double delta=1.0; // 
                          if (cost!=Double.POSITIVE_INFINITY)
                                    {
                                        pumped.add(s);
                                          if (pumped.contains(t))
                                                {
                                                    for (Integer i:new HashSet<Integer>(pushed.keySet()))
                                                    {
                                                        if (i>h)
                                                            if (pushed.containsEntry(i, t))
                                                            {
                                                            if (!pushed.containsEntry((int) (i+delta+1), s))
                                                                    pushed.put((int) (i+delta+1), s);
                                                            break;
                                                            }
                                                        
                                                    }
                                                }
                                                else
                                                {
                                             /*   for (Integer i:new HashSet<Integer>(pushed.keySet()))
                                                       pushed.remove(i,s);*/
                                                //if (!pushed.containsEntry((int) (h+cost), s))
                                              /*  if (n2l.containsKey(t))
                                                {
                                                         pushed.put((int) (n2l.get(t)+cost), s);
                                                         n2l.put(s,(int)(n2l.get(t)+cost));
                                                }
                                                else
                                                {*/
                                                //if (pushed.get(h).contains(s))
                                                    //pushed.put((int) (h+cost+1), s);
                                                /*else
                                                    pushed.put((int) (h+cost), s);*/
                                                 /*  n2l.put(s,(int) (h+cost));
                                                }*/
                                                    pushed.put((int) (h+delta+1), s);
                                                }
                                            break;
                                    }  /*else
                                        testedpostponed.put(s, t);*/
                              
                                
                       }
          }    
        
      }
            }
          catch (Exception e)
          {
              System.out.println(e.getMessage());
          //    System.exit(0);
          }
	done=true;	  
      }

    /*for (String source : level )
     {
     try {
     Thread.sleep(200);
     } catch (InterruptedException ex) {
                                           
     }
     k++;
                            
     //System.out.println("Thread:"+id+" "+k+"/"+level.size());
                            
     Set<String> bblevel = new HashSet<String>(nextlevel);
     //   bblevel.removeAll(removedhere);
     bblevel.remove(source);
     BellmanFordShortestPath sp= new BellmanFordShortestPath(result,source);
                            
     for (String target : bblevel) 
     {
                                    
     if (removedhere.contains(target)) continue;
     Double cost=sp.getCost(target);
     if (cost!=Double.POSITIVE_INFINITY)
     {
     pushed.put(z+h,source);
     removedhere.add(source);
     System.out.println("Thread:"+id+" "+k+"/"+level.size()+" pushed:"+source+" -> "+(z+h));
     bw.write("Thread:"+id+" "+k+"/"+level.size()+" pushed:"+source+" -> "+(z+h)+"\n");
     break;
     } 
     }
     }*/
    @Override
    public Object call() throws Exception {
        //  System.out.println("Thread:"+id+" called");
        run();
        //  System.out.println("Thread:"+id+" finished");
        return true;
    }

}
